/**
	$Id$

	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.list;

import net.sf.basedb.clients.web.plugins.DataLoader;
import net.sf.basedb.clients.web.plugins.ExportedProperty;
import net.sf.basedb.core.DbControl;

/**
	Data loader implementation that acts as a proxy to a ListColumnAction object.
	The table exporter call {@link #getData(DbControl, ExportedProperty, Object)} which
	forwards the call to {@link ListColumnAction#getExportValue(DbControl, Object)}.
	
	@author nicklas
	@since 3.2
*/
public class ListColumnDataLoader<I>
	implements DataLoader<I> 
{

	private final ListColumnAction<I, ?> column;
	
	public ListColumnDataLoader(ListColumnAction<I, ?> column)
	{
		this.column =  column;
	}

	/*
		From the DataLoader interface
		-----------------------------
	*/
	@Override
	public Object getData(DbControl dc, ExportedProperty exportedProperty, I item)
		throws Exception 
	{
		return column.getExportValue(dc, item);
	}
	// -------------------------------
	
}
