/**
	$Id: UnsavedItemException.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) Authors contributing to this file.

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	This exception is thrown when trying to use an item that has not
	been saved to the database in places where this is required. In most
	cases this is the result from trying to use an unsaved item in a query.
	
	@author nicklas
	@version 2.5
	@base.modified $Date: 2008-09-11 22:11:02 +0200 (Thu, 11 Sep 2008) $
*/
public class UnsavedItemException
	extends InvalidDataException
{
	/**
		
	*/
	private static final long serialVersionUID = 9092496684529135233L;

	/**
		Create a new <code>UnsavedItemException</code> object.
	*/
	public UnsavedItemException()
	{
		super();
	}
	
	/**
		Create a new <code>UnsavedItemException</code> object.
	 	@param cause Throwable object that caused this exception. 
	*/
	public UnsavedItemException(Throwable cause)
	{
		super(cause);
	}
	
	/**
		Create a new <code>UnsavedItemException</code> object with the 
		specified <code>message</code>.
	
		@param message The message to throw with the exception
	*/
	public UnsavedItemException(String message)
	{
		super(message);
	}
	
	/**
		Create a new <code>UnsavedItemException</code> object with the 
		specified <code>message</code>.
	
		@param message The message to throw with the exception
	 	@param cause A throwable exception that caused the exception.
	*/
	public UnsavedItemException(String message, Throwable cause)
	{
		super(message, cause);
	}

}
