/*
	$Id: LoginException.java 5822 2011-10-24 11:44:02Z nicklas $

	Copyright (C) 2005 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.authentication;

/**
	This exception can be thrown when an error occurs during the
	authentication, but it is not known if the username or password
	is causing the problem.

	@author Nicklas
	@since 3.0
	@base.modified $Date: 2011-10-24 13:44:02 +0200 (Mon, 24 Oct 2011) $
*/
public class LoginException
	extends AuthenticationException

{

	private static final long serialVersionUID = 1460132978417990852L;

	/**
		Create a new <code>LoginException</code> object
		@param msg The error message
	*/
	public LoginException(String msg)
	{
		super(msg);
	}

	/**
		Create a new <code>LoginException</code> object
		@param cause Another exception which is the cause of the error
	*/
	public LoginException(String msg, Throwable cause)
	{
		super(msg, cause);
	}

}

