/**
	$Id: DiskFileWrapper.java 5374 2010-08-03 09:21:30Z nicklas $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.importer;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

import net.sf.basedb.util.FileUtil;

/**
	File wrapper implementation for files that are located on the local disk.
	
	@author Nicklas
	@since 2.16
	@base.modified $Date: 2010-08-03 11:21:30 +0200 (Tue, 03 Aug 2010) $
*/
public class DiskFileWrapper
	implements FileWrapper
{

	private final File file;
	
	public DiskFileWrapper(File file)
	{
		this.file = file;
	}
	
	/*
		From the FileWrapper interface
		------------------------------
	*/
	@Override
	public String getCharacterSet()
	{
		return null;
	}

	@Override
	public InputStream getInputStream()
		throws IOException
	{
		return FileUtil.getInputStream(file);
	}

	@Override
	public String getName()
	{
		return file.getName();
	}

	@Override
	public long getSize()
	{
		return file.length();
	}
	// -------------------------------
}
