<%-- $Id: edit_unit.jsp 7604 2019-02-25 12:19:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.UNIT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int quantityId = Values.getInt(request.getParameter("quantity_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Quantity quantity = null;
	Unit unit = null;
	List<String> symbols = null;
	if (itemId == 0)
	{
		title = "Create unit";
		cc.removeObject("item");
		quantity = Quantity.getById(dc, quantityId);
	}
	else
	{
		unit = Unit.getById(dc, itemId);
		unit.checkPermission(Permission.WRITE);
		quantity = unit.getQuantity();
		cc.setObject("item", unit);
		title = "Edit unit -- " + HTML.encodeTags(unit.getName());
		Set<String> temp = unit.getSymbols();
		temp.remove(unit.getDisplaySymbol());
		symbols = new ArrayList<String>();
		symbols.add(unit.getDisplaySymbol());
		if (temp.size() > 0) symbols.addAll(temp);
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), unit);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~units.js" styles="toolbar.css,tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="unit">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="quantity_id" value="<%=quantityId%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=unit != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Unit" helpid="unit.edit">
			<table class="fullform input100">
			<tr>
				<th>Title</th>
				<td><input class="text required auto-init" data-auto-init="<%=unit == null ? "focus-select" : "focus" %>" 
					type="text" name="name" 
					value="<%=HTML.encodeTags(unit == null ? Values.getString(cc.getPropertyValue("name"), "New unit") : unit.getName())%>" 
					maxlength="<%=Unit.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="big">
				<th>Symbols</th>
				<td>
					<textarea class="text required" name="symbols" id="symbols" rows="4"
					><%=Values.getString(symbols, "\n", true)%></textarea>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Conversion formula</th>
				<td>
					1 <span id="symbol"><%=unit == null ? "<i>unit</i>" : HTML.encodeTags(unit.getDisplaySymbol())%></span>
					=
						<%=HTML.encodeTags(quantity.getReferenceUnit())%>
					× <input class="text required auto-init" data-auto-init="number-only"
							type="text" name="referenceFactor"
							value="<%=unit == null ? 1.0 : unit.getReferenceFactor()%>"
							maxlength="12" style="width: 10em;">
					+ <input class="text required auto-init" data-auto-init="number-only" 
							type="text" name="referenceOffset"
							value="<%=unit == null ? 0.0 : unit.getReferenceOffset()%>"
							maxlength="12" style="width: 10em;">
				</td>
				<td></td>
			</tr>
			<%
			if (unit != null)
			{
				%>
				<tr>
					<th class="subprompt"></th>
					<td>
						<div class="messagecontainer help" style="margin: 0.5em;">
							Changing the conversion formula triggers a conversion of existing annotation values
							to the new settings. This may result in loss of precision due to rounding or 
							truncation.
						</div>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(unit == null ? cc.getPropertyValue("description") : unit.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
