<%-- $Id: list_bioassays.jsp 7809 2020-05-19 11:35:05Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.FileSet"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.snapshot.AnnotationLoaderUtil"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.NameableFormatter"
	import="net.sf.basedb.clients.web.formatter.LinkedItemFormatter"
	import="net.sf.basedb.clients.web.formatter.DataFileFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ButtonAction" 
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnAction"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.clients.web.util.ProjectSpecificInfoFilter"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
	import="java.util.ArrayList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.DERIVEDBIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
final boolean createRawBioAssayPermission = sc.hasPermission(Permission.CREATE, Item.RAWBIOASSAY);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final Formatter<Nameable> nameableFormatter = mode.hasPropertyLink() ? new LinkedItemFormatter(mode.hasEditLink()) : new NameableFormatter();
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("derived bioassay", "derived bioassays");
final DbControl dc = sc.newDbControl();
ItemResultIterator<DerivedBioAssay> bioAssays = null;
List<AnnotationLoaderUtil> annotationLoaders = new ArrayList<AnnotationLoaderUtil>();
try
{
	ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
	SnapshotManager manager = new SnapshotManager();
	ProjectSpecificInfoFilter psInfo = new ProjectSpecificInfoFilter();
	for (AnnotationType at : annotationTypeQuery.list(dc))
	{
		annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at));
	}
	annotationTypeQuery = Base.getInheritedAnnotationColumns(cc.getSetting("columns"));
	for (AnnotationType at : annotationTypeQuery.list(dc))
	{
		annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at, false, true));
	}
	List<DataFileType> fileTypeColumns = new ArrayList<DataFileType>(Base.getDataFileColumns(itemType, null).list(dc));
	
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	final ItemQuery<ItemSubtype> jobSubtypesQuery = Base.getSubtypesQuery(Item.JOB);

	// Query for parent physical bioassays to the current bioassay
	final ItemQuery<PhysicalBioAssay> physicalBioAssayQuery = PhysicalBioAssay.getQuery();
	physicalBioAssayQuery.setIncludes(cc.getInclude());
	physicalBioAssayQuery.join(Hql.innerJoin("derivedBioAssays", "dba"));
	physicalBioAssayQuery.restrict(Restrictions.eq(Hql.alias("dba"), Expressions.parameter("bioAssay")));
	physicalBioAssayQuery.order(Orders.asc(Hql.property("name"))); 

	// Query for parent bioassays to the current bioassay
	final ItemQuery<DerivedBioAssay> parentQuery = DerivedBioAssay.getQuery();
	parentQuery.setIncludes(cc.getInclude());
	parentQuery.join(Hql.innerJoin("children", "c"));
	parentQuery.restrict(Restrictions.eq(Hql.alias("c"), Expressions.parameter("bioAssay")));
	parentQuery.order(Orders.asc(Hql.property("name"))); 

	// Query for child bioassays to the current bioassay
	final ItemQuery<DerivedBioAssay> childQuery = DerivedBioAssay.getQuery();
	childQuery.setIncludes(cc.getInclude());
	childQuery.join(Hql.innerJoin("parents", "p"));
	childQuery.restrict(Restrictions.eq(Hql.alias("p"), Expressions.parameter("bioAssay")));
	childQuery.order(Orders.asc(Hql.property("name"))); 

	// Query for raw bioassays to the current bioassay
	final ItemQuery<RawBioAssay> rawBioAssayQuery = RawBioAssay.getQuery();
	rawBioAssayQuery.setIncludes(cc.getInclude());
	rawBioAssayQuery.restrict(Restrictions.eq(Hql.property("parentBioAssay"), Expressions.parameter("bioAssay")));
	rawBioAssayQuery.order(Orders.asc(Hql.property("name"))); 

	// List membership
	final ItemQuery<ItemList> listQuery = ItemList.getQuery();
	listQuery.setIncludes(cc.getInclude());
	listQuery.join(Hql.innerJoin("members", "m"));
	listQuery.restrict(Restrictions.eq(Hql.property("memberType"), Expressions.integer(itemType.getValue())));
	listQuery.restrict(Restrictions.eq(Hql.alias("m"), Expressions.parameter("itemId", Type.INT)));
	listQuery.order(Orders.asc(Hql.property("name")));

	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	try
	{
		final ItemQuery<DerivedBioAssay> query = Base.getConfiguredQuery(dc, cc, true, DerivedBioAssay.getQuery(), mode);
		bioAssays = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	ExtensionsInvoker<ButtonAction> invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker<ListColumnAction<DerivedBioAssay,?>> columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title==null ? "Derived bioassays" : title%>" type="<%=mode.getPageType()%>" id="list-page">
	<base:head scripts="table.js,~bioassays.js" styles="table.css,toolbar.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	
	<base:body>
		<h1><%=title==null ? "Derived bioassays" : title%></h1>
		<div class="content">
		<tbl:table 
			id="bioassays" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			filterrows="<%=cc.getFilterRows()%>"
			subclass="fulltable"
			data-inherited-annotations="true"
			data-parent-columns="true"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="itemSubtype"
				property="itemSubtype"
				sortproperty="itemSubtype.name"
				exportproperty="itemSubtype.name:string"
				datatype="int"
				enumeration="<%=Enumeration.fromItems(subtypesQuery.list(dc), "-none-")%>"
				title="Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="physicalBioAssays"
				property="&physicalBioAssays(name)"
				datatype="string"
				title="Physical bioassays"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="parents"
				property="&parents(name)"
				datatype="string"
				title="Parent bioassays"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="children"
				title="Child bioassays"
				property="&children(name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="extract"
				property="extract.name"
				datatype="string"
				title="Extract"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="rawBioAssays"
				title="Raw bioassays"
				property="&rawBioAssays(name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="jobType"
				property="job.itemSubtype"
				sortproperty="job.itemSubtype.name"
				exportproperty="job.itemSubtype.name:string"
				datatype="int"
				enumeration="<%=Enumeration.fromItems(jobSubtypesQuery.list(dc), "-none-")%>"
				title="Job type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="plugin"
				property="job.pluginDefinition.name"
				datatype="string"
				title="Plugin"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="protocol"
				property="protocol.name"
				datatype="string"
				title="Protocol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="kit"
				property="kit.name"
				datatype="string"
				title="Kit"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="hardware"
				property="hardware.name"
				datatype="string"
				title="Hardware"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="software"
				property="software.name"
				datatype="string"
				title="Software"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="entryDate"
				property="entryDate"
				datatype="date"
				title="Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef
				id="itemList"
				property="§itemLists"
				datatype="int"
				title="Item list"
				filterable="true"
				enumeration="<%=Base.getItemListsEnum(dc, itemType, cc.getInclude())%>"
			/>
			<%
			for (AnnotationLoaderUtil loader : annotationLoaders)
			{
				AnnotationType at = loader.getAnnotationType();
				Formatter<Object> formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				Enumeration<String, String> annotationEnum = null;
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					if (!at.getDisplayAsList()) annotationEnum.add("", "-none-");
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = formatter.format(value);
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					subclass="controlled-width"
					id="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+(loader.isSearchingInheritedAnnotations() ? " [I]" : " [A]")%>" 
					property="<%=(loader.isSearchingInheritedAnnotations() ? "##" : "#")+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1 && !loader.isSearchingInheritedAnnotations()%>" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			for (DataFileType ft : fileTypeColumns)
			{
				%>
				<tbl:columndef
					subclass="controlled-width"
					id="<%="ft"+ft.getId()%>"
					title="<%=HTML.encodeTags(ft.getName())+" [F]"%>"
					property="<%="¤" + ft.getId()+"(file.name)"%>"
					exportproperty="<%="¤" + ft.getId()+"(file.path)"%>"
					datatype="string"
					filterable="true"
					sortable="false"
					exportable="true"
					formatter="<%=new DataFileFormatter(dc, ft, mode) %>"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar
					subclass="bottomborder"
					visible="<%=mode.hasToolbar()%>"
					>
					<tbl:button 
						id="btnNewItem"
						disabled="<%=!createPermission%>" 
						image="new.png" 
						title="New&hellip;" 
						tooltip="<%=createPermission ? "Create new derived bioassay" : "You do not have permission to create derived bioassays"%>" 
					/>
					<tbl:button 
						id="btnNewMergedDerivedBioAssay"
						disabled="<%=!createPermission%>" 
						image="new_pooled.png" 
						title="Merge&hellip;" 
						tooltip="<%=createPermission ? "Create new merged bioassay" : "You do not have permission to create derived bioassay"%>" 
					/>
					<tbl:button 
						id="btnDeleteItems"
						image="delete.png"
						title="Delete" 
						tooltip="Delete the selected items" 
					/>
					<tbl:button 
						id="btnRestoreItems"
						image="restore.png"
						title="Restore" 
						tooltip="Restore the selected (deleted) items"
					/>
					<tbl:button 
						id="btnShareItems"
						image="share.png"
						title="Share&hellip;" 
						tooltip="Share the selected items"
					/>
					<tbl:button 
						id="btnSetOwner"
						image="take_ownership.png"
						title="Set owner&hellip;"
						tooltip="Change owner of the selected items"
					/>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button
						id="btnNewItemList"
						image="add.png"
						title="New item list&hellip;"
						tooltip="Create a new item list from matching bioassays"
						visible="<%=sc.hasPermission(Permission.CREATE, Item.ITEMLIST)%>"
					/>
					<tbl:button
						id="btnAddToItemList"
						image="add.png"
						title="Add to item list&hellip;"
						tooltip="Add bioassays to an existing item list"
					/>
					<tbl:button
						id="btnInheritAnnotations"
						image="inherit.png"
						title="Inherit annotations&hellip;"
						tooltip="Batch inherit annotations from parent items"
					/>
					<tbl:button 
						id="btnImport"
						data-plugin-type="IMPORT"
						image="import.png" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						id="btnExport"
						data-plugin-type="EXPORT"
						image="export.png" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						id="btnRunPlugin"
						data-plugin-type="OTHER"
						image="runplugin.png" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer<ButtonAction>(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=bioAssays == null ? 0 : bioAssays.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<%
					int numFilters = cc.getNumPropertyFilters();
					int numRows = cc.getFilterRows();
					for (int filterNo = 0; filterNo < numRows; filterNo++)
					{
						boolean lastRow = filterNo == numRows-1;
						%>
						<tbl:headerrow>
							<tbl:header subclass="index" />
							<tbl:header 
								subclass="check" 
								visible="<%=mode.hasCheck()%>"
								><base:icon 
									subclass="link table-check"
									image="check_uncheck.png" 
									tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
									visible="<%=lastRow%>"
								/></tbl:header>
							<tbl:header 
								subclass="check" 
								visible="<%=mode.hasRadio()%>"
								/>
							<tbl:header 
								subclass="icons" 
								visible="<%=mode.hasIcons()%>"
								>
								<base:icon
									subclass="link table-filter-row-action"
									image="add.png"
									tooltip="Add extra filter row"
									visible="<%=lastRow%>"
								/><base:icon
									subclass="link table-filter-row-action"
									image="remove.png"
									tooltip="Remove this filter row"
									visible="<%=numRows > 1 || numFilters > 0 %>"
									data-remove-row="<%=filterNo%>"
								/>
							</tbl:header>
							<tbl:propertyfilter row="<%=filterNo%>" />
						</tbl:headerrow>
						<%
					}
					%>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (bioAssays != null)
					{						
						while (bioAssays.hasNext())
						{
							DerivedBioAssay item = bioAssays.next();
							int itemId = item.getId();
							boolean usePermission = item.hasPermission(Permission.USE);
							
							
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							String name = HTML.encodeTags(item.getName());
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="deleted.png"
										id="<%="delete."+itemId %>"
										subclass="<%=deletePermission ? "table-delete-item" : "disabled" %>"
										data-item-id="<%=itemId%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon 
										image="shared.png" 
										id="<%="share."+itemId %>"
										subclass="<%=sharePermission ? "table-share-item" : "disabled" %>"
										data-item-id="<%=itemId%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=item.isShared()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div 
									class="link table-item"
									data-item-id="<%=itemId%>"
									data-no-edit="<%=writePermission ? 0 : 1 %>" 
									tabindex="0"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="itemSubtype"><base:propertyvalue 
										item="<%=item%>" 
										property="itemSubtype"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="children">
									<%
									childQuery.setParameter("bioAssay", itemId, Type.INT);
									%>							
									<%=Values.getString(childQuery.list(dc), ", ", false, nameableFormatter) %>
									<base:icon
										subclass="link auto-init"
										data-auto-init="new-child-bioassay"
										data-item-id="<%=itemId %>"
										image="add.png" 
										tooltip="Create new child bioassay" 
										visible="<%=mode.hasEditLink() && createPermission && usePermission %>"
									/>
								</tbl:cell>
								<tbl:cell column="rawBioAssays">
									<%
									rawBioAssayQuery.setParameter("bioAssay", itemId, Type.INT);
									%>							
									<%=Values.getString(rawBioAssayQuery.list(dc), ", ", false, nameableFormatter) %>
									<base:icon
										subclass="link auto-init"
										data-auto-init="new-raw-bioassay"
										data-item-id="<%=itemId %>"
										image="add.png" 
										tooltip="Create new raw bioassay" 
										visible="<%=mode.hasEditLink() && createRawBioAssayPermission && usePermission %>"
									/>
								</tbl:cell>
								<tbl:cell column="physicalBioAssays">
									<%
									physicalBioAssayQuery.setParameter("bioAssay", itemId, Type.INT);
									%>							
									<%=Values.getString(physicalBioAssayQuery.list(dc), ", ", false, nameableFormatter) %>
								</tbl:cell>
								<tbl:cell column="parents">
									<%
									if (!item.isRoot())
									{
										parentQuery.setParameter("bioAssay", itemId, Type.INT);
										%>
										<%=Values.getString(parentQuery.list(dc), ", ", false, nameableFormatter) %>
										<%
									}
									%>							
								</tbl:cell>
								<tbl:cell column="itemList">
									<%
									listQuery.setParameter("itemId", itemId, Type.INT);
									%>
									<%=Values.getString(listQuery.list(dc), ", ", false, nameableFormatter) %>
								</tbl:cell>
								<tbl:cell column="extract"
									><base:propertyvalue 
										item="<%=item%>" 
										property="extract"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="jobType"><base:propertyvalue 
										item="<%=item%>" 
										property="job.itemSubtype"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="plugin"
									><base:propertyvalue 
										item="<%=item%>" 
										property="job.pluginDefinition"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="protocol"
									><base:propertyvalue 
										item="<%=item%>" 
										property="protocol"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="kit"
									><base:propertyvalue 
										item="<%=item%>" 
										property="kit"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="hardware"
									><base:propertyvalue 
										item="<%=item%>"
										property="hardware"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="software"
									><base:propertyvalue 
										item="<%=item%>"
										property="software"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="entryDate" value="<%=item.getEntryDate()%>" />
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<%
								if (item.hasFileSet())
								{
									FileSet fileSet = item.getFileSet();
									for (DataFileType ft : fileTypeColumns)
									{
										%>
										<tbl:cell column="<%="ft"+ft.getId()%>" value="<%=fileSet%>" />
										<%
									}
								}
								if (item.isAnnotated())
								{
									AnnotationSetSnapshot snapshot = manager.getSnapshot(dc, item.getAnnotationSet().getId());
									for (AnnotationLoaderUtil loader : annotationLoaders)
									{
										%>
										<tbl:cell 
											column="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+loader.getId()%>"
											><%
											if (loader.find(snapshot, psInfo.reset())) 
											{
												%><tbl:cellvalue 
													list="<%=loader.getValues()%>"
													suffix="<%=loader.getUnitSymbol()%>"
													clazz="<%=psInfo.overridesDefaultAnnotation() ? "ps-annotation" : null%>"
												/><%
											}
											%></tbl:cell>
										<%
									}
								}
								%>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%=Values.getString(ShareableUtil.getSharedTo(dc, item), ", ", false, nameableFormatter) %>
								</tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
							}
						}
					if (numListed == 0)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer note">
							<%=bioAssays == null || bioAssays.getTotalCount() == 0 ? "No bioassays were found" : "No bioassays on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button id="close" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button id="close" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (bioAssays != null) bioAssays.close();
	if (dc != null) dc.close();
}
%>
